<?php

class CombustiveisController extends Controller
{
    private $combustivelModel;

    public function __construct()
    {
        if (!Sessao::estaLogado()) {
            URL::redirecionar('usuarios/login');
        }
        $this->combustivelModel = $this->model('Combustivel');
    }

    public function index()
    {
        $dados = [
            'combustiveis' => $this->combustivelModel->lerCombustiveis()
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/combustiveis/index.php',
            'dados'    => $dados
        ]);
    }

    public function cadastrar()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'nome'       => strtoupper($formulario['nome'] ?? ''),
                'id_usuario' => $_SESSION['id_usuario'] ?? 1
            ];

            if ($this->combustivelModel->armazenar($dados)) {
                Sessao::mensagem('combustivel', 'Combustível cadastrado com sucesso!');
                URL::redirecionar('combustiveis');
            } else {
                Sessao::mensagem('combustivel', 'Erro ao cadastrar combustível', 'alert alert-danger');
            }
        }

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/combustiveis/cadastrar.php'
        ]);
    }

    public function editar($id)
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'id_combustivel' => $id,
                'nome'           => strtoupper($formulario['nome'] ?? '')
            ];

            if ($this->combustivelModel->atualizar($dados)) {
                Sessao::mensagem('combustivel', 'Combustível atualizado com sucesso!');
                URL::redirecionar('combustiveis');
            } else {
                Sessao::mensagem('combustivel', 'Erro ao atualizar combustível', 'alert alert-danger');
            }
        }

        $combustivel = $this->combustivelModel->lerCombustivelPorId($id);

        $dados = [
            'combustivel' => $combustivel
        ];

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/combustiveis/editar.php',
            'dados'    => $dados
        ]);
    }

    public function visualizar($id)
    {
        $dados = [
            'combustivel' => $this->combustivelModel->lerCombustivelPorId($id)
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/combustiveis/visualizar.php',
            'dados'    => $dados
        ]);
    }

    public function excluir($id)
    {
        if ($this->combustivelModel->remover($id)) {
            Sessao::mensagem('combustivel', 'Combustível removido com sucesso!');
        } else {
            Sessao::mensagem('combustivel', 'Erro ao remover combustível', 'alert alert-danger');
        }
        URL::redirecionar('combustiveis');
    }
}
